import Cache from './Cache.js';

export default class CacheManager {

  static STORAGE = [];

  static init() {
    for (const cache of this.createCaches()) {
      this.STORAGE.push(cache);
      cache.logInit();
    }
  }

  static createCaches() {
    return [
      // new Cache('EXAMPLE_1').hours(2),
      // new Cache('EXAMPLE_2').minutes(2).limit(5),
    ];
  }

  static get(cacheKey, valueKey = null) {
    if (!valueKey) valueKey = cacheKey;
    const cache = this._findCache(cacheKey);
    return cache.get(valueKey);
  }

  static add(cacheKey, value, valueKey = null) {
    if (!valueKey) valueKey = cacheKey;
    const cache = this._findCache(cacheKey);
    return cache.add(valueKey, value);
  }

  static delete(cacheKey, valueKey = null) {
    if (!valueKey) valueKey = cacheKey;
    const cache = this._findCache(cacheKey);
    return cache.delete(valueKey);
  }

  static clear(cacheKey) {
    const cache = this._findCache(cacheKey);
    return cache.clear();
  }

  static _findCache(cacheKey) {
    for (const cache of this.STORAGE) {
      if (cache.key === cacheKey) {
        return cache;
      }
    }
  }

}
